<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_CommonPriceBreakdown StructType
 * @subpackage Structs
 */
class JP_CommonPriceBreakdown extends AbstractStructBase
{
    /**
     * The TtaCodes
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInt
     */
    public $TtaCodes;
    /**
     * The Total
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_CommonPriceBreakdownReduced
     */
    public $Total;
    /**
     * The Commission
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_CommonPriceBreakdownReduced
     */
    public $Commission;
    /**
     * The Type
     * @var string
     */
    public $Type;
    /**
     * The Name
     * @var string
     */
    public $Name;
    /**
     * The Value
     * @var float
     */
    public $Value;
    /**
     * The IsFix
     * @var bool
     */
    public $IsFix;
    /**
     * The TaxAAmount
     * @var float
     */
    public $TaxAAmount;
    /**
     * The TaxBAmount
     * @var float
     */
    public $TaxBAmount;
    /**
     * The ByNight
     * @var bool
     */
    public $ByNight;
    /**
     * The Commissionable
     * @var bool
     */
    public $Commissionable;
    /**
     * The Included
     * @var bool
     */
    public $Included;
    /**
     * Constructor method for JP_CommonPriceBreakdown
     * @uses JP_CommonPriceBreakdown::setTtaCodes()
     * @uses JP_CommonPriceBreakdown::setTotal()
     * @uses JP_CommonPriceBreakdown::setCommission()
     * @uses JP_CommonPriceBreakdown::setType()
     * @uses JP_CommonPriceBreakdown::setName()
     * @uses JP_CommonPriceBreakdown::setValue()
     * @uses JP_CommonPriceBreakdown::setIsFix()
     * @uses JP_CommonPriceBreakdown::setTaxAAmount()
     * @uses JP_CommonPriceBreakdown::setTaxBAmount()
     * @uses JP_CommonPriceBreakdown::setByNight()
     * @uses JP_CommonPriceBreakdown::setCommissionable()
     * @uses JP_CommonPriceBreakdown::setIncluded()
     * @param \ArrayType\ArrayOfInt $ttaCodes
     * @param \StructType\JP_CommonPriceBreakdownReduced $total
     * @param \StructType\JP_CommonPriceBreakdownReduced $commission
     * @param string $type
     * @param string $name
     * @param float $value
     * @param bool $isFix
     * @param float $taxAAmount
     * @param float $taxBAmount
     * @param bool $byNight
     * @param bool $commissionable
     * @param bool $included
     */
    public function __construct(\ArrayType\ArrayOfInt $ttaCodes = null, \StructType\JP_CommonPriceBreakdownReduced $total = null, \StructType\JP_CommonPriceBreakdownReduced $commission = null, $type = null, $name = null, $value = null, $isFix = null, $taxAAmount = null, $taxBAmount = null, $byNight = null, $commissionable = null, $included = null)
    {
        $this
            ->setTtaCodes($ttaCodes)
            ->setTotal($total)
            ->setCommission($commission)
            ->setType($type)
            ->setName($name)
            ->setValue($value)
            ->setIsFix($isFix)
            ->setTaxAAmount($taxAAmount)
            ->setTaxBAmount($taxBAmount)
            ->setByNight($byNight)
            ->setCommissionable($commissionable)
            ->setIncluded($included);
    }
    /**
     * Get TtaCodes value
     * @return \ArrayType\ArrayOfInt|null
     */
    public function getTtaCodes()
    {
        return $this->TtaCodes;
    }
    /**
     * Set TtaCodes value
     * @param \ArrayType\ArrayOfInt $ttaCodes
     * @return \StructType\JP_CommonPriceBreakdown
     */
    public function setTtaCodes(\ArrayType\ArrayOfInt $ttaCodes = null)
    {
        $this->TtaCodes = $ttaCodes;
        return $this;
    }
    /**
     * Get Total value
     * @return \StructType\JP_CommonPriceBreakdownReduced|null
     */
    public function getTotal()
    {
        return $this->Total;
    }
    /**
     * Set Total value
     * @param \StructType\JP_CommonPriceBreakdownReduced $total
     * @return \StructType\JP_CommonPriceBreakdown
     */
    public function setTotal(\StructType\JP_CommonPriceBreakdownReduced $total = null)
    {
        $this->Total = $total;
        return $this;
    }
    /**
     * Get Commission value
     * @return \StructType\JP_CommonPriceBreakdownReduced|null
     */
    public function getCommission()
    {
        return $this->Commission;
    }
    /**
     * Set Commission value
     * @param \StructType\JP_CommonPriceBreakdownReduced $commission
     * @return \StructType\JP_CommonPriceBreakdown
     */
    public function setCommission(\StructType\JP_CommonPriceBreakdownReduced $commission = null)
    {
        $this->Commission = $commission;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \StructType\JP_CommonPriceBreakdown
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_CommonPriceBreakdown
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Value value
     * @return float|null
     */
    public function getValue()
    {
        return $this->Value;
    }
    /**
     * Set Value value
     * @param float $value
     * @return \StructType\JP_CommonPriceBreakdown
     */
    public function setValue($value = null)
    {
        $this->Value = $value;
        return $this;
    }
    /**
     * Get IsFix value
     * @return bool|null
     */
    public function getIsFix()
    {
        return $this->IsFix;
    }
    /**
     * Set IsFix value
     * @param bool $isFix
     * @return \StructType\JP_CommonPriceBreakdown
     */
    public function setIsFix($isFix = null)
    {
        // validation for constraint: boolean
        if (!is_null($isFix) && !is_bool($isFix)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isFix)), __LINE__);
        }
        $this->IsFix = $isFix;
        return $this;
    }
    /**
     * Get TaxAAmount value
     * @return float|null
     */
    public function getTaxAAmount()
    {
        return $this->TaxAAmount;
    }
    /**
     * Set TaxAAmount value
     * @param float $taxAAmount
     * @return \StructType\JP_CommonPriceBreakdown
     */
    public function setTaxAAmount($taxAAmount = null)
    {
        $this->TaxAAmount = $taxAAmount;
        return $this;
    }
    /**
     * Get TaxBAmount value
     * @return float|null
     */
    public function getTaxBAmount()
    {
        return $this->TaxBAmount;
    }
    /**
     * Set TaxBAmount value
     * @param float $taxBAmount
     * @return \StructType\JP_CommonPriceBreakdown
     */
    public function setTaxBAmount($taxBAmount = null)
    {
        $this->TaxBAmount = $taxBAmount;
        return $this;
    }
    /**
     * Get ByNight value
     * @return bool|null
     */
    public function getByNight()
    {
        return $this->ByNight;
    }
    /**
     * Set ByNight value
     * @param bool $byNight
     * @return \StructType\JP_CommonPriceBreakdown
     */
    public function setByNight($byNight = null)
    {
        // validation for constraint: boolean
        if (!is_null($byNight) && !is_bool($byNight)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($byNight)), __LINE__);
        }
        $this->ByNight = $byNight;
        return $this;
    }
    /**
     * Get Commissionable value
     * @return bool|null
     */
    public function getCommissionable()
    {
        return $this->Commissionable;
    }
    /**
     * Set Commissionable value
     * @param bool $commissionable
     * @return \StructType\JP_CommonPriceBreakdown
     */
    public function setCommissionable($commissionable = null)
    {
        // validation for constraint: boolean
        if (!is_null($commissionable) && !is_bool($commissionable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($commissionable)), __LINE__);
        }
        $this->Commissionable = $commissionable;
        return $this;
    }
    /**
     * Get Included value
     * @return bool|null
     */
    public function getIncluded()
    {
        return $this->Included;
    }
    /**
     * Set Included value
     * @param bool $included
     * @return \StructType\JP_CommonPriceBreakdown
     */
    public function setIncluded($included = null)
    {
        // validation for constraint: boolean
        if (!is_null($included) && !is_bool($included)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($included)), __LINE__);
        }
        $this->Included = $included;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_CommonPriceBreakdown
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
